﻿using System;
using System.Collections.Generic;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Media;

namespace WpfBrushEditorTest
{
	public partial class MainWindow : Window
	{
		public MainWindow()
		{
			InitializeComponent();
		}

		private void button1_Click(object sender, RoutedEventArgs e)
		{
			Brush brush = null;
			var dlg = new emanual.Wpf.Controls.WpfBrushEditor();

			if (rdNull.IsChecked == true)
				brush = null;
			else if (rdSolidBrush.IsChecked == true)
				brush = Brushes.RoyalBlue;
			else if (rdLinearBrush.IsChecked == true)
			{
				brush = new LinearGradientBrush();
				((LinearGradientBrush)brush).StartPoint = new Point(0.2, 0.3);
				((LinearGradientBrush)brush).EndPoint = new Point(0.7, 0.8);
				((LinearGradientBrush)brush).GradientStops.Add(new GradientStop(Colors.Gold, 0));
				((LinearGradientBrush)brush).GradientStops.Add(new GradientStop(Colors.Lime, 0.4));
				((LinearGradientBrush)brush).GradientStops.Add(new GradientStop(Colors.Red, 1.0));
			}
			else if (rdRadialBrush.IsChecked == true)
			{
				brush = new RadialGradientBrush();
				((RadialGradientBrush)brush).GradientOrigin = new Point(0.4, 0.6);
				((RadialGradientBrush)brush).Center = new Point(0.6, 0.5);
				((RadialGradientBrush)brush).GradientStops.Add(new GradientStop(Colors.Red, 0.0));
				((RadialGradientBrush)brush).GradientStops.Add(new GradientStop(Colors.LemonChiffon, 0.7));
				((RadialGradientBrush)brush).GradientStops.Add(new GradientStop(Colors.RoyalBlue, 1.0));
				((RadialGradientBrush)brush).RadiusX = 0.4;
				((RadialGradientBrush)brush).RadiusY = 0.6;
			}
			else if (rdImageBrush.IsChecked == true)
			{
				brush = new ImageBrush();
				((ImageBrush)brush).ImageSource = new System.Windows.Media.Imaging.BitmapImage(new Uri("Flag_Red16.png", UriKind.RelativeOrAbsolute));
				((ImageBrush)brush).TileMode = TileMode.Tile;
			}
			else
			{
				Color color = emanual.Wpf.Controls.ColorUtility.ConvertColorFromString(txtColor.Text);
				brush = new SolidColorBrush(color);
			}

			dlg.SelectedBrush = brush;
			dlg.OwnerWindow = this;

			if (dlg.ShowDialog() == true)
			{
				border.Background = dlg.SelectedBrush;

				if (dlg.SelectedBrush is SolidColorBrush)
					txtSelectedColor.Text = ((SolidColorBrush)dlg.SelectedBrush).Color.ToString();
				else
					txtSelectedColor.Text = "";
			}
		}

	} // end of MainWindow class
} // end of namespace
